<script setup lang="ts">
import { type Ref, ref, watch } from 'vue'
import { useMovieStore } from '@/stores/movie'
import BookTicketForm from '@/components/BookTicketForm.vue'
import type { SessionParams } from '@/utils/types'

const props = defineProps<{
  id: string
}>()

const dialog: Ref<boolean> = ref(false)
const loading: Ref<boolean> = ref(false)

const movieStore = useMovieStore()

watch(
  dialog,
  (newValue) => {
    if (!newValue) {
      setTimeout(() => resetDialogData(), 500)
    }
  }
)

const onBookTicketClick = async () => {
  loading.value = true

  const params: SessionParams = {movie_id: props.id}
  await movieStore.getMovieSessions(params)

  openDialog()
}

const resetDialogData = (): void => {
  movieStore.sessions = null
  movieStore.places = null
}

const closeDialog = (): void => {
  dialog.value = false
  loading.value = false
}

const openDialog = (): void => {
  dialog.value = true
  loading.value = false
}
</script>

<template>
  <div class="pt-5 text-center">
    <v-btn class="text-none font-weight-regular text-uppercase"
           text="BOOK TICKET"
           variant="tonal"
           color="indigo"
           block
           :loading="loading"
           @click="onBookTicketClick"
    />
    <v-dialog v-model="dialog" max-width="600">
      <v-card title="Book Ticket">
        <BookTicketForm :id="props.id" @close="closeDialog"/>
      </v-card>
    </v-dialog>
  </div>
</template>
